﻿import caurina.transitions.Tweener;//import tween class
import flash.filters.ColorMatrixFilter;//import color matrix filter class
class com.rubenbristian.BrightnessTween {
	public function BrightnessTween(target:MovieClip, startValue:Number, endValue:Number, time:Number) {
		target.bright = 0;//initial brightness value that will increase/decrease
		Tweener.addTween(target,{bright:endValue, time:time, onComplete:hideAway});//increase/decrease the brightness value
		function hideAway() {
			var changeBrightnessI:Number = setInterval(changeBrightness, 1);//interval that repeats changeBrightness() function every 1ms
			function changeBrightness() {
				target.bright--;
				var brightnessArray:ColorMatrixFilter = new ColorMatrixFilter([1, 0, 0, 0, target.bright, 0, 1, 0, 0, target.bright, 0, 0, 1, 0, target.bright, 0, 0, 0, 1, 0]);//the array that will be used for the changes 
				target.filters = [brightnessArray];//apply the new brightness to the object
				if (target.bright<=0) {//if the values of the current brightness reached the values of the final brightness, clear this interval
					clearInterval(changeBrightnessI);
				}
			}
		}
		var changeBrightnessI:Number = setInterval(changeBrightness, 1);//interval that repeats changeBrightness() function every 1ms
		function changeBrightness() {
			var brightnessArray:ColorMatrixFilter = new ColorMatrixFilter([1, 0, 0, 0, target.bright, 0, 1, 0, 0, target.bright, 0, 0, 1, 0, target.bright, 0, 0, 0, 1, 0]);//the array that will be used for the changes 
			target.filters = [brightnessArray];//apply the new brightness to the object
			if (target.bright>=endValue) {//if the values of the current brightness reached the values of the final brightness, clear this interval
				clearInterval(changeBrightnessI);
			}
		}
	}
}